> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/tong-zhi/notification.requestagreement.md).

# Notification.requestAgreement

> 函数式 API `requestNotificationAgreement`也能用它实现相同功能。

### 功能说明

请求通知同意界面，并将同意结果 `onEvent` 通过回调传递。Toss App Android/iOS `5.255.0` 可在以上版本中使用。

`options.templateCode`请在其中填入在 App in Toss 控制台 > Mini App > 智能发送中编写的模板代码。

以事件风格运行，并以返回值形式接收一个用于解除 App Bridge 回调的函数。收到结果后务必解除。

调用前 `Notification.requestAgreement.isSupported()`可以通过它确认是否支持。在不支持的版本中调用时 `UNSUPPORTED_APP_VERSION` 会发生错误。函数式 API `requestNotificationAgreement`会不受版本限制地尝试订阅。

### 类型

```ts
Notification.requestAgreement(params: RequestNotificationAgreementOptions): () => void;
```

**参数**

```ts
interface RequestNotificationAgreementOptions {
  options: { templateCode: string };
  onEvent: (result: { type: NotificationAgreementResult }) => void;
  onError: (error: unknown) => void | Promise<void>;
}

type NotificationAgreementResult =
  "newAgreement" | "alreadyAgreed" | "agreementRejected";
```

**响应**

返回一个用于解除 App Bridge 回调的 cleanup 函数。

### 错误

错误代码可 `onError`作为……接收，或在包裹调用的 `try/catch`在其中捕获的错误的 `error.code` 值。

| 代码                        | 说明                                                                                                                           |
| ------------------------- | ---------------------------------------------------------------------------------------------------------------------------- |
| `UNSUPPORTED_APP_VERSION` | 如果当前运行的 Toss App 版本不支持此功能，则调用后会立即发生。 `Notification.requestAgreement.isSupported()`请先通过它确认，发生时 `error.message`请向用户显示（更新提示文案）。 |

### 示例代码

```js
import { Notification } from "@apps-in-toss/web-framework";

try {
  const cleanup = Notification.requestAgreement({
    options: { templateCode: "test-template-code" },
    onEvent: (result) => {
      console.log(result.type); // 'newAgreement' | 'alreadyAgreed' | 'agreementRejected'
      cleanup();
    },
    onError: (error) => {
      console.error(error);
      cleanup();
    },
  });
} catch (error) {
  console.error(error);
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/tong-zhi/notification.requestagreement.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
